// -*- C++ -*-
/*!
 * @file DataFlowComponentBase.h
 * @brief DataFlowParticipant RT-Component base class
 * @date $Date: 2007/01/21 14:02:42 $
 * @author Noriaki Ando <n-ando@aist.go.jp>
 *
 * Copyright (C) 2006
 *     Task-intelligence Research Group,
 *     Intelligent Systems Research Institute,
 *     National Institute of
 *         Advanced Industrial Science and Technology (AIST), Japan
 *     All rights reserved.
 *
 * $Id: DataFlowComponentBase.h,v 1.2 2007/01/21 14:02:42 n-ando Exp $
 *
 */

/*
 * $Log: DataFlowComponentBase.h,v $
 * Revision 1.2  2007/01/21 14:02:42  n-ando
 * Kanji-code was changed.
 *
 * Revision 1.1  2007/01/09 09:47:22  n-ando
 * DataFlowParticipant RT-Component base class
 *
 */

#ifndef DataFlowComponentBase_h
#define DataFlowComponentBase_h

#include <rtm/idl/RTCSkel.h>
#include <rtm/RTObject.h>
#include <rtm/PeriodicExecutionContext.h>

namespace RTC
{
  /*!
   * @if jp
   * @class DataFlowComponentBas
   * @brief DataFlowComponentBase 饹
   * @else
   * @class DataFlowComponentBase
   * @brief DataFlowComponentBase class
   * @endif
   */
  class Manager;

  class DataFlowComponentBase
    : public RTObject_impl
      
  {
  public:
    /*!
     * @if jp
     * @brief 󥹥ȥ饯
     * @else
     * @brief Constructor
     * @endif
     */
    DataFlowComponentBase(Manager* manager);


    /*!
     * @if jp
     * @brief ǥȥ饯
     * @else
     * @brief Destructor
     * @endif
     */
    virtual ~DataFlowComponentBase();


    /*!
     * @if jp
     * @brief 
     * @else
     * @brief Initialization
     * @endif
     */
    void init();


  private:
    DataFlowComponent_var m_ref;
    PeriodicExecutionContext* m_pec;
    ExecutionContextService_var m_ecref;
  };

}; // namespace RTC
#endif // DataFlowComponentBase_h
